'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  position: relative;\n'], ['\n  position: relative;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _qrcodeReader = require('qrcode-reader');

var _qrcodeReader2 = _interopRequireDefault(_qrcodeReader);

var _CameraWrapper = require('./components/CameraWrapper');

var _CameraWrapper2 = _interopRequireDefault(_CameraWrapper);

var _CameraPreview = require('./components/CameraPreview');

var _CameraPreview2 = _interopRequireDefault(_CameraPreview);

var _HiddenCanvas = require('./components/HiddenCanvas');

var _HiddenCanvas2 = _interopRequireDefault(_HiddenCanvas);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Wrapper = _styledComponents2.default.div(_templateObject);

var QrCodeScanner = function (_Component) {
  (0, _inherits3.default)(QrCodeScanner, _Component);

  function QrCodeScanner(props) {
    (0, _classCallCheck3.default)(this, QrCodeScanner);

    var _this = (0, _possibleConstructorReturn3.default)(this, (QrCodeScanner.__proto__ || (0, _getPrototypeOf2.default)(QrCodeScanner)).call(this, props));

    _this.state = {
      streamObject: null
    };

    _this.bindVideoStream = _this.bindVideoStream.bind(_this);
    _this.onCreateSnap = _this.onCreateSnap.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(QrCodeScanner, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var navigator = global.window.navigator;
      var _props = this.props,
          width = _props.width,
          height = _props.height;


      if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
        var constraints = {
          audio: false,
          video: {
            width: width,
            height: height,
            aspectRatio: width / height,
            facingMode: 'environment'
          }
        };

        navigator.mediaDevices.getUserMedia(constraints).then(function (stream) {
          _this2.stream = stream;
          _this2.setState(function () {
            return {
              streamObject: stream
            };
          });

          (0, _raf2.default)(_this2.onCreateSnap);
        }).catch(function (error) {
          _this2.setState(function () {
            return { error: error };
          });
        });
      }

      (0, _raf2.default)(this.bindVideoStream);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.stream) {
        this.stream.getTracks().forEach(function (track) {
          return track.stop();
        });
      }
    }
  }, {
    key: 'onCreateSnap',
    value: function onCreateSnap() {
      var _this3 = this;

      var _props2 = this.props,
          onQrCodeScanned = _props2.onQrCodeScanned,
          width = _props2.width,
          height = _props2.height;

      var qr = new _qrcodeReader2.default();
      var context = this.canvas && this.canvas.getContext('2d');

      if (context) {
        context.drawImage(this.videoTag, 0, 0, width, height, 0, 0, width, height);
      }

      var imageData = this.canvas.toDataURL('image/png');

      qr.callback = function (error, result) {
        if (error) return (0, _raf2.default)(_this3.onCreateSnap);

        _this3.videoTag.pause();
        _this3.stream.getTracks().forEach(function (track) {
          return track.stop();
        });
        return onQrCodeScanned(result);
      };

      qr.decode(imageData);
    }
  }, {
    key: 'bindVideoStream',
    value: function bindVideoStream() {
      if (this.videoTag != null) {
        this.videoTag.srcObject = this.stream;
        return;
      }

      (0, _raf2.default)(this.bindVideoStream);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _state = this.state,
          streamObject = _state.streamObject,
          error = _state.error;
      var _props3 = this.props,
          width = _props3.width,
          height = _props3.height,
          showAimAssist = _props3.showAimAssist;


      if (error) {
        return _react2.default.createElement(
          Wrapper,
          null,
          'An error occurred:',
          _react2.default.createElement(
            'pre',
            null,
            error.name,
            error.message
          ),
          'Try a different phone'
        );
      }

      return _react2.default.createElement(
        Wrapper,
        { innerRef: function innerRef(el) {
            _this4.wrapper = el;
          } },
        streamObject && _react2.default.createElement(
          _CameraWrapper2.default,
          {
            showAimAssist: showAimAssist
          },
          _react2.default.createElement(_CameraPreview2.default, {
            videoRef: function videoRef(el) {
              _this4.videoTag = el;
            }
          }),
          _react2.default.createElement(_HiddenCanvas2.default, {
            innerRef: function innerRef(el) {
              _this4.canvas = el;
            },
            width: width,
            height: height
          })
        )
      );
    }
  }]);
  return QrCodeScanner;
}(_react.Component);

QrCodeScanner.propTypes = {
  onQrCodeScanned: _propTypes2.default.func.isRequired,
  width: _propTypes2.default.number,
  height: _propTypes2.default.number,
  showAimAssist: _propTypes2.default.bool
};

QrCodeScanner.defaultProps = {
  onQrCodeScanned: function onQrCodeScanned(result) {
    return console && console.log('RESULT', result);
  },
  width: global.window ? global.window.innerWidth : 360,
  height: global.window ? global.window.innerHeight : 480,
  showAimAssist: true
};

exports.default = QrCodeScanner;